.o-card {
  box-shadow: 0.25rem 0.5rem 1.5rem var(--black-alpha-15);
  margin-bottom: 2rem;
  border-radius: 1rem;

  &__container {
    position: relative;
    z-index: 1;
    background: var(--white);
    padding: 1rem;
    border-radius: 1rem;
    box-shadow: 0.125rem 0.25rem 0.75rem var(--black-alpha-10);

    &.-no-padding {
      padding: 0;
    }
  }

  &__context {
    background-color: var(--black-100);
    padding: 1rem;
    position: relative;
    color: var(--white);
    border-radius: 0 0 1rem 1rem;

    &::before {
      content: "";
      display: block;
      position: absolute;
      top: -1rem;
      height: 1rem;
      left: 0;
      width: 100%;
      background: inherit;
    }
  }

  &__title {
    font-size: 1.5rem;
    margin-top: 0;
    margin-bottom: 1rem;
    padding-bottom: 1rem;
    border-bottom: 2px solid var(--black-25);
    text-align: center;
    font-weight: 500;

    &__icon {
      margin-right: 0.25rem;
      vertical-align: bottom;
    }
  }

  &__title-loading {
    margin: 0.2rem auto;
    width: 8rem;
    height: 1.35rem;
    position: relative;
    overflow: hidden;
    border-radius: 0.25rem;
    background-color: rgba(var(--theme-green-primary-values), 0.05);
    background-image: linear-gradient(
      90deg,
      rgba(var(--theme-green-primary-values), 0.05) 0%,
      rgba(var(--theme-green-secondary-values), 0.05) 100%
    );

    &::after {
      position: absolute;
      content: "";
      display: block;
      width: 100%;
      top: 0;
      bottom: 0;
      background-image: linear-gradient(
        90deg,
        transparent 0%,
        rgba(var(--theme-green-primary-values), 0.15) 15%,
        rgba(var(--theme-green-primary-values), 0.15) 40%,
        transparent 55%
      );
      transform: translateX(0);
      animation-name: data-loading;
      animation-duration: 1.5s;
      animation-iteration-count: infinite;
      animation-timing-function: linear;
    }
  }

  &.-transparent {
    .o-card__container {
      background-color: var(--white-alpha-85);
    }
  }

  &.-orange {
    .o-card__context {
      background-color: var(var(--theme-orange-primary));
      background-image: linear-gradient(
        90deg,
        var(--theme-orange-primary) 0%,
        var(--theme-orange-secondary) 100%
      );
    }

    .o-card__title {
      border-bottom: 2px solid rgba(var(--theme-orange-primary-values), 0.2);
      border-image-source: linear-gradient(
        90deg,
        rgba(var(--theme-orange-primary-values), 0.2) 0%,
        rgba(var(--theme-orange-secondary-values), 0.2) 100%
      );
      background-color: var(var(--theme-orange-primary));
      background-image: linear-gradient(
        90deg,
        var(--theme-orange-primary) 0%,
        var(--theme-orange-secondary) 100%
      );
    }
  }

  &.-blue {
    .o-card__context {
      background-color: var(--theme-blue-primary);
      background-image: linear-gradient(
        90deg,
        var(--theme-blue-primary) 0%,
        var(--theme-blue-secondary) 100%
      );
    }

    .o-card__title {
      border-bottom: 2px solid rgba(var(--theme-blue-primary-values), 0.2);
      border-image-source: linear-gradient(
        90deg,
        rgba(var(--theme-blue-primary-values), 0.2) 0%,
        rgba(var(--theme-blue-secondary-values), 0.2) 100%
      );
      background-color: var(--theme-blue-primary);
      background-image: linear-gradient(
        90deg,
        var(--theme-blue-primary) 0%,
        var(--theme-blue-secondary) 100%
      );
    }
  }

  &.-purple {
    .o-card__context {
      background-color: var(--theme-purple-primary);
      background-image: linear-gradient(
        90deg,
        var(--theme-purple-primary) 0%,
        var(--theme-purple-secondary) 100%
      );
    }

    .o-card__title {
      border-bottom: 2px solid rgba(var(--theme-purple-primary-values), 0.2);
      border-image-source: linear-gradient(
        90deg,
        rgba(var(--theme-purple-primary-values), 0.2) 0%,
        rgba(var(--theme-purple-secondary-values), 0.2) 100%
      );
      background-color: var(--theme-purple-primary);
      background-image: linear-gradient(
        90deg,
        var(--theme-purple-primary) 0%,
        var(--theme-purple-secondary) 100%
      );
    }
  }

  &.-green {
    .o-card__context {
      background-color: var(--theme-green-primary);
      background-image: linear-gradient(
        90deg,
        var(--theme-green-primary) 0%,
        var(--theme-green-secondary) 100%
      );
    }

    .o-card__title {
      border-bottom: 2px solid rgba(var(--theme-green-primary-values), 0.2);
      border-image-source: linear-gradient(
        90deg,
        rgba(var(--theme-green-primary-values), 0.2) 0%,
        rgba(var(--theme-green-secondary-values), 0.2) 100%
      );
      background-color: var(--theme-green-primary);
      background-image: linear-gradient(
        90deg,
        var(--theme-green-primary) 0%,
        var(--theme-green-secondary) 100%
      );
    }
  }

  &.-orange,
  &.-blue,
  &.-purple,
  &.-green {
    .o-card__title {
      border-image-slice: 1;
      background-clip: text;
      -webkit-text-fill-color: transparent;

      mat-icon {
        display: initial;
      }
    }
  }

  &.-last {
    margin-bottom: 0;
  }

  &.-compact {
    margin-bottom: 1rem;
  }

  &.-no-overflow {
    overflow: hidden;
  }
}
